## NMDeviceIPTunnel

NMDeviceIPTunnel

## Functions

NMDevice * | nm_device_ip_tunnel_get_parent ()
NMIPTunnelMode | nm_device_ip_tunnel_get_mode ()
const char * | nm_device_ip_tunnel_get_local ()
const char * | nm_device_ip_tunnel_get_remote ()
guint8 | nm_device_ip_tunnel_get_ttl ()
guint8 | nm_device_ip_tunnel_get_tos ()
gboolean | nm_device_ip_tunnel_get_path_mtu_discovery ()
const char * | nm_device_ip_tunnel_get_input_key ()
const char * | nm_device_ip_tunnel_get_output_key ()
guint8 | nm_device_ip_tunnel_get_encapsulation_limit ()
guint | nm_device_ip_tunnel_get_flow_label ()
NMIPTunnelFlags | nm_device_ip_tunnel_get_flags ()

## Types and Values

#define | NM_DEVICE_IP_TUNNEL_MODE
#define | NM_DEVICE_IP_TUNNEL_PARENT
#define | NM_DEVICE_IP_TUNNEL_LOCAL
#define | NM_DEVICE_IP_TUNNEL_REMOTE
#define | NM_DEVICE_IP_TUNNEL_TTL
#define | NM_DEVICE_IP_TUNNEL_TOS
#define | NM_DEVICE_IP_TUNNEL_PATH_MTU_DISCOVERY
#define | NM_DEVICE_IP_TUNNEL_INPUT_KEY
#define | NM_DEVICE_IP_TUNNEL_OUTPUT_KEY
#define | NM_DEVICE_IP_TUNNEL_ENCAPSULATION_LIMIT
#define | NM_DEVICE_IP_TUNNEL_FLOW_LABEL
#define | NM_DEVICE_IP_TUNNEL_FLAGS

## Description

## Functions

### nm_device_ip_tunnel_get_parent ()

    NMDevice *
    nm_device_ip_tunnel_get_parent (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the device's parent device.

[transfer none]

Since: 1.2

### nm_device_ip_tunnel_get_mode ()

    NMIPTunnelMode
    nm_device_ip_tunnel_get_mode (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the tunneling mode

Since: 1.2

### nm_device_ip_tunnel_get_local ()

    const char *
    nm_device_ip_tunnel_get_local (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the local endpoint of the tunnel

Since: 1.2

### nm_device_ip_tunnel_get_remote ()

    const char *
    nm_device_ip_tunnel_get_remote (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the remote endpoint of the tunnel

Since: 1.2

### nm_device_ip_tunnel_get_ttl ()

    guint8
    nm_device_ip_tunnel_get_ttl (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the TTL assigned to tunneled packets

Since: 1.2

### nm_device_ip_tunnel_get_tos ()

    guint8
    nm_device_ip_tunnel_get_tos (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

type of service (IPv4) or traffic class (IPv6) assigned to tunneled packets.

Since: 1.2

### nm_device_ip_tunnel_get_path_mtu_discovery ()

    gboolean
    nm_device_ip_tunnel_get_path_mtu_discovery
                                   (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

whether path MTU discovery is enabled

Since: 1.2

### nm_device_ip_tunnel_get_input_key ()

    const char *
    nm_device_ip_tunnel_get_input_key (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the key used for incoming packets

Since: 1.2

### nm_device_ip_tunnel_get_output_key ()

    const char *
    nm_device_ip_tunnel_get_output_key (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the key used for outgoing packets

Since: 1.2

### nm_device_ip_tunnel_get_encapsulation_limit ()

    guint8
    nm_device_ip_tunnel_get_encapsulation_limit
                                   (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the maximum permitted encapsulation level

Since: 1.2

### nm_device_ip_tunnel_get_flow_label ()

    guint
    nm_device_ip_tunnel_get_flow_label (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the flow label assigned to tunnel packets

Since: 1.2

### nm_device_ip_tunnel_get_flags ()

    NMIPTunnelFlags
    nm_device_ip_tunnel_get_flags (NMDeviceIPTunnel *device);

#### Parameters

device | a NMDeviceIPTunnel |

#### Returns

the tunnel flags

Since: 1.12

## Types and Values

### NM_DEVICE_IP_TUNNEL_MODE

    #define NM_DEVICE_IP_TUNNEL_MODE                "mode"

### NM_DEVICE_IP_TUNNEL_PARENT

    #define NM_DEVICE_IP_TUNNEL_PARENT              "parent"

### NM_DEVICE_IP_TUNNEL_LOCAL

    #define NM_DEVICE_IP_TUNNEL_LOCAL               "local"

### NM_DEVICE_IP_TUNNEL_REMOTE

    #define NM_DEVICE_IP_TUNNEL_REMOTE              "remote"

### NM_DEVICE_IP_TUNNEL_TTL

    #define NM_DEVICE_IP_TUNNEL_TTL                 "ttl"

### NM_DEVICE_IP_TUNNEL_TOS

    #define NM_DEVICE_IP_TUNNEL_TOS                 "tos"

### NM_DEVICE_IP_TUNNEL_PATH_MTU_DISCOVERY

    #define NM_DEVICE_IP_TUNNEL_PATH_MTU_DISCOVERY  "path-mtu-discovery"

### NM_DEVICE_IP_TUNNEL_INPUT_KEY

    #define NM_DEVICE_IP_TUNNEL_INPUT_KEY           "input-key"

### NM_DEVICE_IP_TUNNEL_OUTPUT_KEY

    #define NM_DEVICE_IP_TUNNEL_OUTPUT_KEY          "output-key"

### NM_DEVICE_IP_TUNNEL_ENCAPSULATION_LIMIT

    #define NM_DEVICE_IP_TUNNEL_ENCAPSULATION_LIMIT "encapsulation-limit"

### NM_DEVICE_IP_TUNNEL_FLOW_LABEL

    #define NM_DEVICE_IP_TUNNEL_FLOW_LABEL          "flow-label"

### NM_DEVICE_IP_TUNNEL_FLAGS

    #define NM_DEVICE_IP_TUNNEL_FLAGS               "flags"